module Isomorfeus
  class AssetManager
    class RubyImport
      attr_reader :module_name

      def initialize(ruby_module)
        @ruby_module = ruby_module.end_with?('.rb') ? ruby_module : ruby_module + '.rb'
        @module_name = @ruby_module[0..-4]
        @import_name = @module_name.tr('/', '_')
      end

      def resolved_path
        @resolved_path ||= resolve_path
      end

      def to_s
        "import(\"./#{@module_name}.js\");\n"
      end

      private

      def resolve_path
        split_ruby_path = @ruby_module.split('/')
        Opal.paths.each do |path|
          file = File.expand_path(File.join(*path.split('/').concat(split_ruby_path)))
          return file if File.exist?(file)
        end
        STDERR.puts "#{self.class.name}: unable to resolve ruby module #{@module_name}"
        nil
      end
    end
  end
end
